# Ephemeral API Documentation

Ephemeral uses a cool hidden input type on the upload form to say that the upload is coming from a browser.
If the "source" value is not set to "web", then the server will return json.
Additionally, if the program detects that you don't have `Mozilla/5.0` in the user agent, the server will return the JSON api response instead.

This API Documentation is for the JSON responses.

This is not entirely accurate, as it includes planned features like
editing ttd, and looking at file information.

## File Uploading - `/`

POST - endpoint receives a file, returns the following.

`{"file": "FAFHHSW.txt", "url": "https://cz0.au/FAFHHSW.txt", "adminurl": "https://cz0.au/edit/64f2fhdsFSGQ", "expiry": 1677123536}`

- File: The name of the file uploaded.
- url: the URL of the file.
- adminurl: the admin URL of the file, currently, this just deletes the file.
- expiry: The expiry of the file, in unix time.

Returns `{"error": "BlockedMimetype"}` if the Mimetype is not allowed to be uploaded (as set in config.toml)
Returns `{"error": "MissingUploadKey"}` if the server requires a key to upload files.
Returns `{"error": "InternalServerError"}` if there was something wrong with copying the file to the filestore.
Returns `{"error": "BadRequest"}` if there was a error parsing the request that was sent.

## File Serving - `/<file>`

GET - Retrieves the file with the given ID, performing syntax highlighting and rendering a template if matching known plain-text file. (otherwise just plaintext, OR rendered by browser)

## File information - `/edit/<key>`

Returns information about the file with the corresponding key.

- URL
- filename
- current expiry
- popularity/fileviews

If the key is invalid returns a 401, same with all children API Endpoints

## File Deletion - `/edit/<key>` (also `/delete/<key>` for backwards compatibility.)

Deletes the file with the corresponding key. This is immediate and permanent.

When successful, returns `{"deletion": "success"}`

Accepts GET and DELETE - as long as it has the keys.

## File expiry Change - `/edit/<key>/ttd`

If GET, reads the expiry from the DB and responds with it.
If POST, tries it's best to overwrite the expiry. This will fail if the expiry is futher away than the current.

This is in unix time.
