# Database documentation

The database connection is saved in a pool, and the pool serves out a connection to any object that needs them.

At the moment, we use SQLX, with SQLite, however I'd really like to support Postgres and the rest soon, SQLite is slow, buggy and annoying.

## files.db

### files table

- **file** as text - contains the filename (with filetype!)
- **filetype** as text - contains the file extension. (this is onl used for stats, and easy moderation) - at this point it is only grabbed from the extension, but later on we could use mimetype guessing to guess files without a type. However it's almost always text, and will be rendered as so.
- **expiry** as int - contains unix time of when the file will be deleted - AS COMPUTED BY ENGINE MODE. (this is kept as is, never changed after initial upload)
- **expiry_override** - _can_ contain unixtime of when the file will actaully be deleted, if it's set, this is used for overriding files.
- **views** - counts up for each view to the file.
- **isDeleted** - simple flag to archive the thing in the DB.
- **adminkey** - key for deletion and setting expiry_override
- **accessed** - last time the file was accessed
- **filesize** - size of the file, in kb or something idk
- **ip** - IP Address of the uploader, for legal and statistics purposes!
- **domain** - Domain the file was originally uploaded to.

### qrscan table

- **scanid** as autoincrement int, for primary key.
- **time** as int - when the qr code was scanned
- **ip** as text? - who scanned it.
- **version** as int - simple int for the version of qrcode, so I can track what edition the qrcodes are. (/qr1/2/3/4/5/6)

### stats table

Hopefully we can move away from having a separate stats table, and use metrics generated from the files table instead.
(or maybe not for performance - might be cheaper to keep the stats table and update it every minute or so.)

### API Keys Table

This is used for premium users.
API Keys have a few permission flags, they can be `true` or `false`.

1. server_admin: Allows the user to generate new API Keys
2. expiry_override: Allows the user to bypass the default expiry of a file. (but not past the file_expiry_max)
3. upload_permanent: Allows the user to upload a file that's stored permanently.
4. default_name: Allows the user to upload a file, keeping the filename.
5. bypass_mimetypes: Allows the user to upload a file that normally would be banned.