# Stuff and things

This means each website can have a completely independant theme, and if you put each server behind cloudflare, you would never really know that they're running on the same server.

Additionally, I'll have to add file uploading in a similar way. where there is a domain under `files/` that organises uploaded files.

## Better Grafana Stuff

Generating decent, useable stats is a problem with the quadfile that annoyed me, my first implementation didn't track stats well enough.
I'm grouping the stats into 3 categories, each with a different scope "global", "filetype" and "file". This makes it easy to figure out what I'll need to query from the database in the future.

Deleted files should no longer show up in most stats generated, since storing the same block of data forever is a waste. They're not going to change anyway.

### General Stats

- Total number of files alive /right now/ `total_alive{filetype='*', host="localhost"}`
- Total number of files uploaded `total_alive{filetype='*', host="localhost"}`
- Total number of files uploaded (by x ip) `filecount_ip`
- Total filesize of alive files `filesize_alive`
- Total filesize of dead files `filesize_dead`
- Total bandwidth served for alive files(calculated by views * filesize) `bandwidth_alive{file="*"}` (this will need to be done per file)
- Total bandwidth served for dead files(calculated by views * filesize) `bandwidth_dead{file="*"}` (this will need to be done per file)
- Geo-map of files uploaded (I'm not too sure how we can do this)
- Geo-map of files served (would require nginx logs)
- Scrape render time `render_time`

### Filetype Stats (Pick a filetype from the list, or even multiple?)

- Total number of alive files uploaded (by x filetype) `total_alive{filetype=mp4}`
- Total number of dead files (by x filetype) `total_dead{filetype=mp4}`
- Total filesize of alive files `filesize_alive{filetype=mp4}`
- Total filesize of dead files `filesize_dead{filetype=mp4}`
- Total number of views for dead files `views_dead{filetype=mp4}`
- Total number of views for alive files `views_alive{filetype=mp4}`
- Total bandwidth for mimetype `file_bandwidth{mimetype="*"}` ()
- Filesize Graph (Average/total? filesize per filetype) ?
- Filesize Graph (Filesize vs lifetime) ?

### File Stats (Pick a individual file from a list, or even multiple?)

- Total Views on file `file_views{file="bleh.txt", mimetype="text/plain"}`
- Total Bandwidth per file `file_bandwidth{file="bleh.txt", mimetype="text/plain"}`
- File Size `filesize{file=hUMZCp.jpg}`

### Malicious/Error Stats

- Total Number of files blocked by x filetype
- Total number of files blocked (by x ip)
- Total number of errors (by x error type)
- Filename generation collision errors
- Adminkey generation collision errors

## File Deletion

### Adminkey deletion

1. DELETE or GET `/delete/<adminkey>` request.
2. Check in db if adminkey has a valid filename that isn't already deleted.
3. if it is valid, and not deleted, flag it in the DB as deleted, else we're done here.
4. if that worked, delete the file from the DB.
5. all done!

### expiry deletion

1. todo thread runs, and checks all files that aren't deleted already for expirydates PAST the current time.
2. iterates through all files, and marks them as deleted and delete from disk.
3. Wait for next timer.

# TODO's

TODO: See how many .unwraps I can handle to make this thing potentially crash less, and offer more decent errors.
TODO: Test the guess_ip function behind nginx properly, I don't know if ipv6/unix socket works at all, or if they're passed through the ipv4.
TODO: Figure out why you get "There was a problem with the file upload request. Please try again." when you upload a file with `cat bleh | supload -Vd http://127.0.0.1:8282/ -`
