pub(crate) mod tests {
    use sqlx::{sqlite::SqlitePoolOptions, SqlitePool};

    /// Initialise the in-memory database for tests.
    pub async fn init_test_db() -> Result<SqlitePool, sqlx::Error> {
        // Create the database pool object
        let pool = SqlitePoolOptions::new().connect("sqlite::memory:").await?;

        // Create the necessary tables and indices
        sqlx::query(
            "
                CREATE TABLE IF NOT EXISTS 'files' (
                file TEXT NOT NULL,
                mimetype TEXT NOT NULL,
                expiry INTEGER NOT NULL,
                expiry_override INTEGER,
                views INTEGER DEFAULT '0',
                isDeleted INTEGER DEFAULT '0',
                adminkey TEXT NOT NULL,
                accessed INTEGER NOT NULL,
                filesize INTEGER NOT NULL,
                IP TEXT NOT NULL,
                domain TEXT NOT NULL
            );
        ",
        )
        .execute(&pool)
        .await?;

        Ok(pool)
    }
}
